Index: guiframe/data_manager.py
===================================================================
--- guiframe/data_manager.py	(revision 03482452ef9a332c6837e62eff2ce71d9d608371)
+++ guiframe/data_manager.py	(revision a07e72f8fb8281178797bf691b36e56274d8580b)
@@ -23,4 +23,6 @@
 from sans.guiframe.dataFitting import Data2D
   
+import wx
+
 class DataManager(object):
     """
@@ -77,7 +79,7 @@
         new_plot.interactive = True
         ## when 2 data have the same id override the 1 st plotted
-        new_plot.id = name
+        new_plot.id = wx.NewId()
         ##group_id specify on which panel to plot this data
-        new_plot.group_id = name
+        new_plot.group_id = [wx.NewId()]
         new_plot.is_data = True
         new_plot.path = path
@@ -151,5 +153,4 @@
         """
         """
-        print "append theory", self.stored_data, data_id
         if data_id in self.stored_data:
             data_state = self.stored_data[data_id]
Index: guiframe/events.py
===================================================================
--- guiframe/events.py	(revision 4e4d3bb9dfac5ed6bc357291ff34909ee62258d6)
+++ guiframe/events.py	(revision a07e72f8fb8281178797bf691b36e56274d8580b)
@@ -16,6 +16,4 @@
 #slicer event
 (SlicerEvent, EVT_SLICER)   = wx.lib.newevent.NewEvent()
-# event containinG A DICTIONARY OF NAME and errors of selected data
-(ErrorDataEvent, ERR_DATA) = wx.lib.newevent.NewEvent()
 ## event that that destroy a page associate with Data1D removed from the graph
 (RemoveDataEvent, EVT_REMOVE_DATA)   = wx.lib.newevent.NewEvent()
Index: guiframe/gui_manager.py
===================================================================
--- guiframe/gui_manager.py	(revision 4c0572f4279d3b0619eca4d40af9f5266816f5be)
+++ guiframe/gui_manager.py	(revision a07e72f8fb8281178797bf691b36e56274d8580b)
@@ -431,5 +431,5 @@
                                   Hide())        
       
-    def get_context_menu(self, graph=None):
+    def get_context_menu(self, plotpanel=None):
         """
         Get the context menu items made available 
@@ -437,8 +437,9 @@
         This function is used by the plotting module
         """
+        if plotpanel is None:
+            return
         menu_list = []
         for item in self.plugins:
-            if hasattr(item, "get_context_menu"):
-                menu_list.extend(item.get_context_menu(graph))
+            menu_list.extend(item.get_context_menu(plotpanel=plotpanel))
         return menu_list
         
Index: guiframe/gui_style.py
===================================================================
--- guiframe/gui_style.py	(revision 59a4a750b2260e7dcd390d2d458e9caf2db169a6)
+++ guiframe/gui_style.py	(revision a07e72f8fb8281178797bf691b36e56274d8580b)
@@ -33,4 +33,5 @@
     PRINT_ID = wx.NewId()
     CURRENT_APPLICATION = wx.NewId()
+    CURVE_SYMBOL_NUM = 13
     
 class GUIFRAME_ICON:
Index: guiframe/local_perspectives/plotting/Plotter1D.py
===================================================================
--- guiframe/local_perspectives/plotting/Plotter1D.py	(revision a45037aaea7a183fd246884e3c1340d9e6d7fb7a)
+++ guiframe/local_perspectives/plotting/Plotter1D.py	(revision a07e72f8fb8281178797bf691b36e56274d8580b)
@@ -18,5 +18,5 @@
 import numpy
 import time
-import danse.common.plottools
+
 from danse.common.plottools.PlotPanel import PlotPanel
 from danse.common.plottools.plottables import Graph
@@ -26,5 +26,4 @@
 from sans.guiframe.events import NewPlotEvent
 from sans.guiframe.events import SlicerEvent
-from sans.guiframe.events import ErrorDataEvent
 from sans.guiframe.events import RemoveDataEvent
 from sans.guiframe.events import PanelOnFocusEvent
@@ -32,5 +31,4 @@
 from sans.guiframe.utils import PanelMenu
 from sans.guiframe.dataFitting import Data1D
-from sans.guiframe.dataFitting import Theory1D
 from sans.guiframe.panel_base import PanelBase
 from binder import BindArtist
@@ -67,16 +65,13 @@
         #context menu
         self._slicerpop = None
-        self._menu_add_plot = None
+        
         self._available_data = []
         self._menu_add_ids = []
-        ## save errors dy  for each data plotted
-        self.err_dy = {}
-        ## flag to determine if the hide or show context menu item should
-        ## be displayed
-        self.errors_hide = False
+        self._symbol_labels = self.get_symbol_label()
+      
+        self.hide_menu = None
         ## Unique ID (from gui_manager)
         self.uid = None
-        ## Action IDs for internal call-backs
-        self.action_ids = {}
+       
         ## Default locations
         self._default_save_location = os.getcwd()        
@@ -86,34 +81,41 @@
         self.graph.yaxis("\\rm{Intensity} ", "cm^{-1}")
         self.graph.render(self)
-        #bind with event to contrst context menu
-        #self.parent.Bind(EVT_NEW_LOADED_DATA, self._add_new_plot)
-        
-    def on_add_new_plot(self, event):
-        """
-        """
-    def _add_new_plot(self, event):
-        """
-        Construct the context menu given available data
-        """
-        self._available_data = event.data_to_add
+       
+    def get_symbol_label(self):
+        """
+        Associates label to symbol
+        """
+        _labels = {}
+        i = 0
+        _labels['Points'] = i
+        i += 1
+        _labels['X '] = i
+        i += 1
+        _labels['Triangle Down'] = i
+        i += 1
+        _labels['Triangle Up'] = i
+        i += 1
+        _labels['Triangle Left'] = i
+        i += 1
+        _labels['Triangle Right'] = i
+        i += 1
+        _labels['Plus'] = i
+        i += 1
+        _labels['Square'] = i
+        i += 1
+        _labels['Thin Diamond'] = i
+        i += 1
+        _labels['Diamond'] = i
+        i += 1
+        _labels['Hexagon1'] = i
+        i += 1
+        _labels['Hexagon2'] = i
+        i += 1
+        _labels['Pentagon'] = i
+        i += 1
+        _labels['Curve'] = i
+        return _labels
+
     
-    def _fill_menu_add_plot(self):
-        """
-        """
-        if self._menu_add_plot is not None:
-            if self._available_data:
-                for id in self._menu_add_ids:
-                    item = self._menu_add_plot.FindItemById(id)
-                    if item is None:
-                        for data in self._available_data:
-                            new_id = wx.NewId()
-                            hint = 'Add %s to this panel' % str(data.name)
-                            self._menu_add_plot.Append(new_id, str(data.name), hint)
-                            wx.EVT_MENU(self, id, self.on_add_new_plot)
-                            self._menu_add_ids.append(new_id)
-                    else:
-                        if item.GetLabel() == 'No Loaded Data':
-                            self._menu_add_plot.RemoveItem(item)
-                        
     def set_data(self, list=None):
         """
@@ -127,7 +129,28 @@
         self.graph.reset()
         self.plots      = {}
-        self.action_ids = {}
     
-    def _onEVT_1DREPLOT(self, event):
+    def remove_data_by_id(self, id):
+        """'
+        remove data from plot
+        """
+        if id in self.plots.keys():
+            data =  self.plots[id]
+            self.graph.delete(data)
+            data_manager = self._manager.parent.get_data_manager()
+            data_list = data_manager.get_by_id(id_list=[id])
+            data = data_list.values()[0].data
+            data.group_id.remove(self.group_id)
+            del self.plots[id]
+                 
+            self.graph.render(self)
+            self.subplot.figure.canvas.draw_idle()    
+            if len(self.graph.plottables) == 0:
+                print "_onRemove: graph is empty must be destroyed"
+           
+        else:
+            msg = "Attempt to remove an unexisting plot with ID %s " % str(id)
+            raise ValueError, msg
+        
+    def plot_data(self, data):
         """
         Data is ready to be displayed
@@ -135,57 +158,16 @@
         :param event: data event
         """
-        #TODO: Check for existence of plot attribute
-        # Check whether this is a replot. If we ask for a replot
-        # and the plottable no longer exists, ignore the event.
-        if hasattr(event, "update") and event.update == True \
-            and event.plot.name not in self.plots.keys():
-            return
-        if hasattr(event, "reset"):
-            self._reset()
-        # Check whether the plottable is empty
-        is_empty = len(event.plot.x) == 0
-                
-        is_new = True
-        if event.plot.name in self.plots.keys():
-            # If the plottable is empty, just remove the plottable from the graph
-            if is_empty:
-                self.graph.delete(self.plots[event.plot.name])
-                del self.plots[event.plot.name]
-            else:  
-                # Check whether the class of plottable changed
-                if not event.plot.__class__ == self.plots[event.plot.name].__class__:
-                    #overwrite a plottable using the same name
-                    self.graph.delete(self.plots[event.plot.name])              
-                else:
-                    # plottable is already draw on the panel
-                    is_new = False
-        
-        if not is_empty:
-            if is_new:
-                # a new plottable overwrites a plotted one  using the same id
-                for plottable in self.plots.itervalues():
-                    if hasattr(event.plot, "id") and hasattr(plottable, "id"):
-                        #remove the existing plot and same id and same name
-                        if event.plot.id == plottable.id and \
-                            event.plot.name == plottable.name:
-                            self.graph.delete(plottable)
-                
-                self.plots[event.plot.name] = event.plot
-                self.graph.add(self.plots[event.plot.name])
-            else:
-                #replot the graph
-                self.plots[event.plot.name].x = event.plot.x    
-                self.plots[event.plot.name].y = event.plot.y    
-                self.plots[event.plot.name].dy = event.plot.dy  
-                if hasattr(event.plot, 'dx') and \
-                    hasattr(self.plots[event.plot.name], 'dx'):
-                    self.plots[event.plot.name].dx = event.plot.dx    
-          
-        #TODO: Should re-factor this
-        ## for all added plot the option to hide error show be displayed first
-        #self.errors_hide = 0
-        ## Set axis labels
-        self.graph.xaxis(event.plot._xaxis, event.plot._xunit)
-        self.graph.yaxis(event.plot._yaxis, event.plot._yunit)
+        if data.id in self.plots.keys():
+            #replace
+            self.graph.replace(data)
+            self.plots[data.id] = data
+        else:
+            self.plots[data.id] = data
+            self.graph.add(self.plots[data.id]) 
+        
+        x_label, x_unit = data.get_xaxis()
+        y_label, y_unit = data.get_yaxis()
+        self.graph.xaxis(x_unit, x_label)
+        self.graph.yaxis(y_unit, y_label)
         ## Set the view scale for all plots
         self._onEVT_FUNC_PROPERTY()
@@ -193,9 +175,6 @@
         self.graph.render(self)
         self.subplot.figure.canvas.draw_idle()
-        #if self.errors_hide:
-        #    self._on_remove_errors(evt=None)
-        #else:
-        #    self._on_add_errors( evt=None)
-    
+
+       
     def onLeftDown(self,event): 
         """ 
@@ -211,5 +190,20 @@
         #post nd event to notify guiframe that this panel is on focus
         wx.PostEvent(self.parent, PanelOnFocusEvent(panel=self))
-        
+        self._manager.set_panel_on_focus(self)
+        
+    def _ontoggle_hide_error(self, event):
+        """
+        Toggle error display to hide or show
+        """
+        
+        selected_plot = self.plots[self.graph.selected_plottable]
+        if self.hide_menu.GetText() == "Hide Error":
+            selected_plot.hide_error = True
+        else:
+            selected_plot.hide_error = False
+        ## increment graph color
+        self.graph.render(self)
+        self.subplot.figure.canvas.draw_idle()  
+          
     def _onRemove(self, event):
         """
@@ -219,18 +213,14 @@
         
         """
-        selected_plot = self.plots[self.graph.selected_plottable]
         ## Check if there is a selected graph to remove
-        if not self.graph.selected_plottable == None and\
-            self.graph.selected_plottable in self.plots.keys():
-            color = self.graph.plottables[selected_plot]
+        if self.graph.selected_plottable in self.plots.keys():
+            selected_plot = self.plots[self.graph.selected_plottable]
+            id = self.graph.selected_plottable
+            self.remove_data_by_id( id)
             event = RemoveDataEvent(data=selected_plot)
             wx.PostEvent(self.parent, event)
             self.graph.delete(selected_plot)
             del selected_plot
-            ## increment graph color
-            self.graph.color += color
-            self.graph.render(self)
-            self.subplot.figure.canvas.draw_idle()    
-           
+       
     def onContextMenu(self, event):
         """
@@ -253,18 +243,16 @@
         self._slicerpop.Append(id, '&Print Preview', 'image preview for print')
         wx.EVT_MENU(self, id, self.onPrinterPreview)
-        """
-        #add plot
-        self._menu_add_plot = wx.Menu()
-        id = wx.NewId()
-        self._menu_add_plot.Append(id, '&No Loaded Data', 'Add new plot')
-        self._menu_add_plot.FindItemByPosition(0).Enable(False)
-        self._menu_add_ids.append(id)
-        
-        self._slicerpop.AppendSubMenu(self._menu_add_plot, '&Add New Plot')
-        self._fill_menu_add_plot()
-        """
+        
+        symbol_menu = wx.Menu()
+        for label in self._symbol_labels:
+            id = wx.NewId()
+            symbol_menu.Append(id, str(label), str(label))
+            wx.EVT_MENU(self, id, self.onChangeSymbol)
+        id = wx.NewId()
+        self._slicerpop.AppendMenu(id,'&Modify Symbol',  symbol_menu)
         self._slicerpop.AppendSeparator()
+        
         #add menu of other plugins
-        item_list = self.parent.get_context_menu(self.graph)
+        item_list = self.parent.get_context_menu(self)
         if (not item_list == None) and (not len(item_list) == 0):
             for item in item_list:
@@ -275,10 +263,10 @@
                 except:
                     msg = "ModelPanel1D.onContextMenu: "
-                    msg += "bad menu item  %s"%sys.exc_value
+                    msg += "bad menu item  %s" % sys.exc_value
                     wx.PostEvent(self.parent, StatusEvent(status=msg))
                     pass
             self._slicerpop.AppendSeparator()
         id = wx.NewId()
-        self._menu_add_plot = wx.Menu()
+        
         self._slicerpop.Append(id, '&Print image', 'Print image')
         if self.graph.selected_plottable in self.plots:
@@ -287,19 +275,26 @@
             name = plot.name
             self._slicerpop.Append(id, "&Save points")
-            self.action_ids[str(id)] = plot
             wx.EVT_MENU(self, id, self._onSave)
             id = wx.NewId()
             self._slicerpop.Append(id, "Remove %s curve" % name)
-            self.action_ids[str(id)] = plot
             wx.EVT_MENU(self, id, self._onRemove)
+            id = wx.NewId()
+            self.hide_menu = self._slicerpop.Append(id, "Hide Error")
+            if plot.dy is not None or plot.dy != []:
+                if plot.hide_error :
+                    self.hide_menu.SetText('Show Error')
+                else:
+                    self.hide_menu.SetText('Hide Error')
+            else:
+                self.hide_menu.Disable()
+            wx.EVT_MENU(self, id, self._ontoggle_hide_error)
+            
             self._slicerpop.AppendSeparator()
             # Option to hide
             #TODO: implement functionality to hide a plottable (legend click)
-        if self.graph.selected_plottable in self.plots:
-            selected_plot = self.plots[self.graph.selected_plottable]
-            id = wx.NewId()
-            self._slicerpop.Append(id, '&Linear fit')
-            wx.EVT_MENU(self, id, self.onFitting)
-            self._slicerpop.AppendSeparator()
+        id = wx.NewId()
+        self._slicerpop.Append(id, '&Linear Fit')
+        wx.EVT_MENU(self, id, self.onFitting)
+        
         id = wx.NewId()
         self._slicerpop.Append(id, '&Change scale')
@@ -311,149 +306,19 @@
         pos = self.ScreenToClient(pos)
         self.PopupMenu(self._slicerpop, pos)
-        
-    def _on_remove_errors(self, evt):
-        """
-        Save name and dy of data in dictionary self.err_dy
-        Create a new data1D with the same x, y
-        vector and dy with zeros.
-        post self.err_dy as event (ErrorDataEvent) for any object
-        which wants to reconstruct the initial data.
-        
-        :param evt: Menu event
-        
-        """
-        if not self.graph.selected_plottable == None:
-            ## store existing dy
-            name =self.plots[self.graph.selected_plottable].name
-            dy = self.plots[self.graph.selected_plottable].dy
-            self.err_dy[name] = dy
-            ## Create a new dy for a new plottable
-            #import numpy
-            dy = numpy.zeros(len(self.plots[self.graph.selected_plottable].y))
-            selected_plot = self.plots[self.graph.selected_plottable]
-            
-            if selected_plot.__class__.__name__ == "Data1D":
-                # Make sure that we can pass a basic Data1D
-                dxl = None
-                dxw = None
-                if hasattr(selected_plot, "dxl"):
-                    dxl = selected_plot.dxl
-                if hasattr(selected_plot, "dxw"):
-                    dxw = selected_plot.dxw
-                new_plot = Data1D(x=selected_plot.x, y=selected_plot.y,
-                               dx=selected_plot.dx, dy=dy)
-                new_plot.dxl = dxl
-                new_plot.dxw = dxw            
-            else:
-                 new_plot = Theory1D(x=selected_plot.x, 
-                                     y=selected_plot.y, dy=dy)
-            new_plot.interactive = True
-            self.errors_hide = True
-            new_plot.name = self.plots[self.graph.selected_plottable].name 
-            if hasattr(self.plots[self.graph.selected_plottable], "group_id"):
-                new_plot.group_id = self.plots[self.graph.selected_plottable].group_id
-                if hasattr(self.plots[self.graph.selected_plottable], "id"):
-                    new_plot.id = self.plots[self.graph.selected_plottable].id
-                else:
-                    new_plot.id = str(time.time())
-            else:
-                new_plot.group_id = str(time.time())
-                new_plot.id = str(time.time())
-            label, unit = self.plots[self.graph.selected_plottable].get_xaxis()
-            new_plot.xaxis(label, unit)
-            label, unit = self.plots[self.graph.selected_plottable].get_yaxis()
-            new_plot.yaxis(label, unit)
-            ## save the color of the selected plottable before it is deleted
-            color = self.graph.plottables[self.plots[self.graph.selected_plottable]]
-            self.graph.delete(self.plots[self.graph.selected_plottable])
-            ## add newly created plottable to the graph with the save color
-            self.graph.color += color
-            self.graph.add(new_plot, color)
-            ## transforming the view of the new data into the same of 
-            #the previous data
-            self._onEVT_FUNC_PROPERTY()
-            ## save the plot 
-            self.plots[self.graph.selected_plottable] = new_plot
-            ## Render the graph
-            self.graph.render(self)
-            self.subplot.figure.canvas.draw_idle() 
-            event = ErrorDataEvent(err_dy=self.err_dy)
-            wx.PostEvent(self.parent, event)
-
-    def _on_add_errors(self, evt):
-        """
-        create a new data1D witht the errors saved in self.err_dy
-        to show errors of the plot.
-        Compute reasonable errors for a data set without 
-        errors and transorm the plottable to a Data1D
-        
-        :param evt: Menu event
-        
-        """
-        if not self.graph.selected_plottable == None \
-            and self.graph.selected_plottable in self.plots.keys():
-            ##Reset the flag to display the hide option on the context menu
-            self.errors_hide = False
-            ## restore dy 
-            length = len(self.plots[self.graph.selected_plottable].x)
-            dy = numpy.zeros(length)
-            selected_plot = self.plots[self.graph.selected_plottable]
-            try:
-                dy = self.err_dy[selected_plot.name]
-            except:
-                if hasattr(selected_plot, "dy"):
-                    dy = selected_plot.dy
-                else:
-                    dy = numpy.zeros(selected_plot.dy)
-            ## Create a new plottable data1D
-            if selected_plot.__class__.__name__ == "Data1D":
-                # Make sure that we can pass a basic Data1D
-                dxl = None
-                dxw = None
-                if hasattr(selected_plot, "dxl"):
-                    dxl = selected_plot.dxl
-                if hasattr(selected_plot, "dxw"):
-                    dxw = selected_plot.dxw
-                new_plot = Data1D(x=selected_plot.x,
-                                               y=selected_plot.y,
-                                               dx=selected_plot.dx,
-                                               dy=dy)
-                new_plot.dxl = dxl
-                new_plot.dxw = dxw                       
-            else:
-                ## Create a new plottable Theory1D
-                new_plot = Theory1D(x=selected_plot.x, y=selected_plot.y, dy=dy)
-            new_plot.interactive = True
-            new_plot.name = self.plots[self.graph.selected_plottable].name 
-            if hasattr(self.plots[self.graph.selected_plottable], "group_id"):
-                new_plot.group_id = self.plots[self.graph.selected_plottable].group_id
-                if hasattr(self.plots[self.graph.selected_plottable],"id"):
-                    new_plot.id = self.plots[self.graph.selected_plottable].id
-                else:
-                    new_plot.id = str(time.time())
-            else:
-                new_plot.group_id = str(time.time())
-                new_plot.id = str(time.time())
-            
-            label, unit = self.plots[self.graph.selected_plottable].get_xaxis()
-            new_plot.xaxis(label, unit)
-            label, unit = self.plots[self.graph.selected_plottable].get_yaxis()
-            new_plot.yaxis(label, unit)
-            ## save the color of the selected plottable before it is deleted
-            color=self.graph.plottables[self.plots[self.graph.selected_plottable]]
-            self.graph.delete(self.plots[self.graph.selected_plottable])
-            self.graph.color += color
-            ## add newly created plottable to the graph with the save color
-            self.graph.add(new_plot, color)
-            ## transforming the view of the new data into the same of
-            # the previous data
-            self._onEVT_FUNC_PROPERTY()
-            ## save the plot 
-            self.plots[self.graph.selected_plottable]=new_plot
-            ## render the graph with its new content
-            self.graph.render(self)
-            self.subplot.figure.canvas.draw_idle() 
-               
-               
+     
+    def onChangeSymbol(self, event):
+        """
+        """
+        menu = event.GetEventObject()
+        id = event.GetId()
+        label =  menu.GetLabel(id)
+        selected_plot = self.plots[self.graph.selected_plottable]
+        selected_plot.symbol = self._symbol_labels[label]
+        ## Set the view scale for all plots
+        self._onEVT_FUNC_PROPERTY()
+        ## render the graph
+        self.graph.render(self)
+        self.subplot.figure.canvas.draw_idle()
+        
     def _onsaveTXT(self, path):
         """
@@ -503,36 +368,34 @@
         
         """
-        id = str(evt.GetId())
-        if id in self.action_ids:         
+       
+        path = None
+        wildcard = "Text files (*.txt)|*.txt|"\
+        "CanSAS 1D files(*.xml)|*.xml" 
+        dlg = wx.FileDialog(self, "Choose a file",
+                            self._default_save_location,
+                             "", wildcard , wx.SAVE)
+       
+        if dlg.ShowModal() == wx.ID_OK:
+            path = dlg.GetPath()
+            mypath = os.path.basename(path)
             
-            path = None
-            wildcard = "Text files (*.txt)|*.txt|"\
-            "CanSAS 1D files(*.xml)|*.xml" 
-            dlg = wx.FileDialog(self, "Choose a file",
-                                self._default_save_location,
-                                 "", wildcard , wx.SAVE)
-           
-            if dlg.ShowModal() == wx.ID_OK:
-                path = dlg.GetPath()
-                mypath = os.path.basename(path)
-                
-                #TODO: This is bad design. The DataLoader is designed 
-                #to recognize extensions.
-                # It should be a simple matter of calling the .
-                #save(file, data, '.xml') method
-                # of the DataLoader.loader.Loader class.
-                from DataLoader.loader import  Loader
-                #Instantiate a loader 
-                loader = Loader() 
-                data = self.plots[self.graph.selected_plottable]
-                format = ".txt"
-                if os.path.splitext(mypath)[1].lower() == format:
-                     self._onsaveTXT( path)
-                format = ".xml"
-                if os.path.splitext(mypath)[1].lower() == format:
-                    loader.save(path, data, format)
-                try:
-                    self._default_save_location = os.path.dirname(path)
-                except:
-                    pass    
-            dlg.Destroy()
+            #TODO: This is bad design. The DataLoader is designed 
+            #to recognize extensions.
+            # It should be a simple matter of calling the .
+            #save(file, data, '.xml') method
+            # of the DataLoader.loader.Loader class.
+            from DataLoader.loader import  Loader
+            #Instantiate a loader 
+            loader = Loader() 
+            data = self.plots[self.graph.selected_plottable]
+            format = ".txt"
+            if os.path.splitext(mypath)[1].lower() == format:
+                 self._onsaveTXT( path)
+            format = ".xml"
+            if os.path.splitext(mypath)[1].lower() == format:
+                loader.save(path, data, format)
+            try:
+                self._default_save_location = os.path.dirname(path)
+            except:
+                pass    
+        dlg.Destroy()
